@echo off &setlocal enableDelayedExpansion

if "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto 64BIT
echo 32-bit OS
set NZFSVARIANCE=x86
goto CHECKSERVICESTATE

:64BIT
echo 64-bit OS
set NZFSVARIANCE=x64
goto CHECKSERVICESTATE

:CHECKSERVICESTATE
sc query NZFSB | FIND /i "NZFSB"
IF ERRORLEVEL 1 goto SERVICEALREADYREMOVED
goto STOP

:STOP
sc stop NZFSB
IF ERRORLEVEL 1 goto REMOVESERVICE
echo Please wait...
call "%~dp0helper\wait" 31
goto REMOVESERVICE

:SERVICEALREADYREMOVED
echo Service has already been remove! Skipping...
goto REMOVEDRIVERCHECK

:REMOVESERVICE
sc delete NZFSB
IF ERRORLEVEL 1 goto ERROR
goto REMOVEDRIVERCHECK

:REMOVEDRIVERCHECK
call "%~dp0%NZFSVARIANCE%\private.exe" find root\NZFSD | FIND /i "1"
IF ERRORLEVEL 1 goto DRIVERALREADYREMOVED
goto REMOVEDRIVER

:DRIVERALREADYREMOVED
echo Driver has already been removed! Exiting....
goto END

:REMOVEDRIVER
ver | FIND /i " 5."
IF ERRORLEVEL 1 goto PNP
goto NOPNP

:PNP
set NZFSCOMMANDDIR=%~dp0%NZFSVARIANCE%

set NZFSOEM=
call "%~dp0helper\get-inf"
IF ERRORLEVEL 1 goto ERROR

call :StartsWith %NZFSOEM% "oem" 
if %ERRORLEVEL%==0 (
  echo OEM %NZFSOEM%
) else (
   echo OEM not found
   goto ERROR
)

call "%~dp0%NZFSVARIANCE%\private.exe" disable "%~dp0NZFS-SAS.inf" root\NZFSD
IF ERRORLEVEL 1 goto ERROR
call "%~dp0helper\wait" 3

call "%~dp0%NZFSVARIANCE%\private.exe" remove "%~dp0NZFS-SAS.inf" root\NZFSD
IF ERRORLEVEL 1 goto ERROR
call "%~dp0helper\wait" 3

pnputil -f -d %NZFSOEM%
goto DELETESERVICE

:NOPNP
call "%~dp0%NZFSVARIANCE%\private.exe" disable "%~dp0NZFS-SAS.inf" root\NZFSD
IF ERRORLEVEL 1 goto ERROR
call "%~dp0helper\wait" 3

call "%~dp0%NZFSVARIANCE%\private.exe" remove "%~dp0NZFS-SAS.inf" root\NZFSD
IF ERRORLEVEL 1 goto ERROR
call "%~dp0helper\wait" 3

:DELETESERVICE
sc delete NZFSD
IF ERRORLEVEL 1 goto ERROR
goto END

:ERROR
echo Error = %ERRORLEVEL%
goto END

:StartsWith text string -- Tests if a text starts with a given string
::                      -- [IN] text   - text to be searched
::                      -- [IN] string - string to be tested for
:$created 20080320 :$changed 20080320 :$categories StringOperation,Condition
:$source http://www.dostips.com
SETLOCAL
set "txt=%~1"
set "str=%~2"
if defined str call set "s=%str%%%txt:*%str%=%%"
if /i "%txt%" NEQ "%s%" set=2>NUL
EXIT /b

:END

pause